--[[ Stack Tile ]]--

lick = require "lick"
lick.reset = true

HC = require "HardonCollider"

TILE_SIZE = 25
MAP_WIDTH = 26
MAP_HEIGHT = 24
N_MAPS = 1

function love.load()
  -- Set up player
  player = {}
  player.x = 250 + TILE_SIZE
  player.y = TILE_SIZE
  player.speed = 1000

  -- Load all map images
  map_loader = require("AdvTiledLoader.Loader")
  map_loader.path = "maps/"
  maps = {}
  for i = 1, N_MAPS do
    maps[i] = map_loader.load("map" .. i .. ".tmx")
  end

  -- Set up collider
  collider = HC(100, on_collide)
  player_rect = collider:addRectangle(player.x, player.y, TILE_SIZE, TILE_SIZE)
  solid_tiles = get_solid_tiles(maps[1])
end

function love.update(dt)
  if love.keyboard.isDown("right") then
    player.x = player.x + player.speed * dt
  end
  if love.keyboard.isDown("left") then
    player.x = player.x - player.speed * dt
  end
  if love.keyboard.isDown("down") then
    player.y = player.y + player.speed * dt
  end
  if love.keyboard.isDown("up") then
    player.y = player.y - player.speed * dt
  end

  collider:update(dt)
end

function love.draw()
  love.graphics.push()
  love.graphics.translate(250, 0)
  maps[1]:draw()
  love.graphics.pop()

  --love.graphics.rectangle("fill", player.x, player.y, TILE_SIZE, TILE_SIZE)
  player_rect:draw("fill")
end

function on_collide(dt, shape_a, shape_b, mtv_x, mtv_y)
  print("Hey")
end

function get_solid_tiles(map)
  local collidable_tiles = {}

  local layer = map.tl["ground"]

  for tileX, tileY, tile in layer.tileData:iterate() do
      print(tile)

      if tile and tile.properties.solid then
        print("hey")
        local ctile = collider:addRectangle((tileX - 1) * 16, (tileY - 1) * 16, 16, 16)
        ctile.type = "tile"
        collider:addToGroup("tiles", ctile)
        collider:setPassive(ctile)
        table.insert(collidable_tiles, ctile)
      end
  end

  print(#collidable_tiles)
  return collidable_tiles
end